diff -uwr sourceold/AntiSpawnKill/AntiSpawnKill.cpp source/AntiSpawnKill/AntiSpawnKill.cpp
--- sourceold/AntiSpawnKill/AntiSpawnKill.cpp	2011-10-11 21:31:00.611328100 +0800
+++ source/AntiSpawnKill/AntiSpawnKill.cpp	2012-01-11 22:18:59.639648400 +0800
@@ -15,6 +15,11 @@
 
 bool waskilled[128];
 
+void* HookupAT3x(void* a, void* b, void* c, void* patch_start, void* patch_end, int (*version_selector)())
+{
+	return HookupAT3(a,b,c,patch_start,patch_end,version_selector);
+}
+
 class ANTISPAWNKILL : public Plugin
 {
 public:
diff -uwr sourceold/CTF/CTF.cpp source/CTF/CTF.cpp
--- sourceold/CTF/CTF.cpp	2011-12-07 11:55:00.500000000 +0800
+++ source/CTF/CTF.cpp	2012-01-11 22:13:42.196289000 +0800
@@ -20,6 +20,11 @@
 #include "PowerupGameObjDef.h"
 GameObject *CTFController = 0;
 
+void* HookupAT3x(void* a, void* b, void* c, void* patch_start, void* patch_end, int (*version_selector)())
+{
+	return HookupAT3(a,b,c,patch_start,patch_end,version_selector);
+}
+
 char *CTFIcons[4][2] = {
 	//{Model,Animation},
 	{"",""},
diff -uwr sourceold/CharacterRefund/CharacterRefund.cpp source/CharacterRefund/CharacterRefund.cpp
--- sourceold/CharacterRefund/CharacterRefund.cpp	2011-10-11 21:32:22.065429600 +0800
+++ source/CharacterRefund/CharacterRefund.cpp	2012-01-11 22:19:11.657226500 +0800
@@ -14,6 +14,11 @@
 #include "gmgame.h"
 
 
+void* HookupAT3x(void* a, void* b, void* c, void* patch_start, void* patch_end, int (*version_selector)())
+{
+	return HookupAT3(a,b,c,patch_start,patch_end,version_selector);
+}
+
 bool waskilled[128];
 int currval[128];
 
diff -uwr sourceold/ExtraConsoleCommands/ExtraConsoleCommands.cpp source/ExtraConsoleCommands/ExtraConsoleCommands.cpp
--- sourceold/ExtraConsoleCommands/ExtraConsoleCommands.cpp	2011-11-07 20:10:56.345703100 +0800
+++ source/ExtraConsoleCommands/ExtraConsoleCommands.cpp	2012-01-11 22:14:43.544921800 +0800
@@ -18,6 +18,11 @@
 #include "gmlog.h"
 #include "engine_tt.h"
 
+void* HookupAT3x(void* a, void* b, void* c, void* patch_start, void* patch_end, int (*version_selector)())
+{
+	return HookupAT3(a,b,c,patch_start,patch_end,version_selector);
+}
+
 static int getClientIdByIdentifier(const char* clientIdentifier)
 {
 	assert(clientIdentifier);
diff -uwr sourceold/FirstBlood/FirstBlood.cpp source/FirstBlood/FirstBlood.cpp
--- sourceold/FirstBlood/FirstBlood.cpp	2011-10-11 21:34:04.078125000 +0800
+++ source/FirstBlood/FirstBlood.cpp	2012-01-11 22:19:59.439453100 +0800
@@ -13,6 +13,11 @@
 #include "FirstBlood.h"
 #include "gmgame.h"
 
+void* HookupAT3x(void* a, void* b, void* c, void* patch_start, void* patch_end, int (*version_selector)())
+{
+	return HookupAT3(a,b,c,patch_start,patch_end,version_selector);
+}
+
 bool first = false;
 
 class FIRSTBLOOD : public Plugin
diff -uwr sourceold/Mute/Mute.cpp source/Mute/Mute.cpp
--- sourceold/Mute/Mute.cpp	2011-11-07 20:10:56.260742100 +0800
+++ source/Mute/Mute.cpp	2012-01-11 22:15:17.976562500 +0800
@@ -18,6 +18,11 @@
 
 bool MutedPlayers[128];
 
+void* HookupAT3x(void* a, void* b, void* c, void* patch_start, void* patch_end, int (*version_selector)())
+{
+	return HookupAT3(a,b,c,patch_start,patch_end,version_selector);
+}
+
 static int getClientIdByIdentifier(const char* clientIdentifier)
 {
 	assert(clientIdentifier);
diff -uwr sourceold/NoPoints/NoPoints.cpp source/NoPoints/NoPoints.cpp
--- sourceold/NoPoints/NoPoints.cpp	2011-10-11 21:35:52.521484300 +0800
+++ source/NoPoints/NoPoints.cpp	2012-01-11 22:20:33.491210900 +0800
@@ -14,6 +14,10 @@
 #include "gmgame.h"
 #include "GameObjManager.h"
 
+void* HookupAT3x(void* a, void* b, void* c, void* patch_start, void* patch_end, int (*version_selector)())
+{
+	return HookupAT3(a,b,c,patch_start,patch_end,version_selector);
+}
 
 
 class NOPOINTS : public Plugin
diff -uwr sourceold/PointsDistribution/PointsDistribution.cpp source/PointsDistribution/PointsDistribution.cpp
--- sourceold/PointsDistribution/PointsDistribution.cpp	2011-11-26 08:54:08.823242100 +0800
+++ source/PointsDistribution/PointsDistribution.cpp	2012-01-11 22:20:50.635742100 +0800
@@ -15,6 +15,10 @@
 #include "gmgame.h"
 #include "Iterator.h"
 
+void* HookupAT3x(void* a, void* b, void* c, void* patch_start, void* patch_end, int (*version_selector)())
+{
+	return HookupAT3(a,b,c,patch_start,patch_end,version_selector);
+}
 
 
 class POINTSDISTRIBUTION : public Plugin
diff -uwr sourceold/Spectate/Spectate.cpp source/Spectate/Spectate.cpp
--- sourceold/Spectate/Spectate.cpp	2011-11-07 20:10:56.307617100 +0800
+++ source/Spectate/Spectate.cpp	2012-01-11 22:21:06.802734300 +0800
@@ -20,6 +20,11 @@
 #include "engine_weap.h"
 #include "engine_obj2.h"
 
+void* HookupAT3x(void* a, void* b, void* c, void* patch_start, void* patch_end, int (*version_selector)())
+{
+	return HookupAT3(a,b,c,patch_start,patch_end,version_selector);
+}
+
 static int getClientIdByIdentifier(const char* clientIdentifier)
 {
 	assert(clientIdentifier);
diff -uwr sourceold/SuddenDeath/SuddenDeath.cpp source/SuddenDeath/SuddenDeath.cpp
--- sourceold/SuddenDeath/SuddenDeath.cpp	2011-11-07 20:10:56.581054600 +0800
+++ source/SuddenDeath/SuddenDeath.cpp	2012-01-11 22:16:29.383789000 +0800
@@ -18,6 +18,11 @@
 #include "VehicleGameObj.h"
 #include "engine_tt.h"
 
+void* HookupAT3x(void* a, void* b, void* c, void* patch_start, void* patch_end, int (*version_selector)())
+{
+	return HookupAT3(a,b,c,patch_start,patch_end,version_selector);
+}
+
 static int getClientIdByIdentifier(const char* clientIdentifier)
 {
 	assert(clientIdentifier);
diff -uwr sourceold/bansystem/bansystem.cpp source/bansystem/bansystem.cpp
--- sourceold/bansystem/bansystem.cpp	2011-11-07 20:10:56.543945300 +0800
+++ source/bansystem/bansystem.cpp	2012-01-11 22:16:48.831054600 +0800
@@ -17,6 +17,11 @@
 #include "engine_tt.h"
 #include "gmgame.h"
 
+void* HookupAT3x(void* a, void* b, void* c, void* patch_start, void* patch_end, int (*version_selector)())
+{
+	return HookupAT3(a,b,c,patch_start,patch_end,version_selector);
+}
+
 static int getClientIdByIdentifier(const char* clientIdentifier)
 {
 	assert(clientIdentifier);
Files sourceold/bin/Debug/shaders.lib and source/bin/Debug/shaders.lib differ
Files sourceold/bin/Release/shaders.lib and source/bin/Release/shaders.lib differ
diff -uwr sourceold/crates/crates.cpp source/crates/crates.cpp
--- sourceold/crates/crates.cpp	2011-12-05 15:38:18.435078100 +0800
+++ source/crates/crates.cpp	2012-01-11 22:29:04.188476500 +0800
@@ -18,6 +18,10 @@
 #include "PurchaseSettingsDefClass.h"
 #include "PowerupGameObj.h"
 #include "PowerupGameObjDef.h"
+void* HookupAT3x(void* a, void* b, void* c, void* patch_start, void* patch_end, int (*version_selector)())
+{
+	return HookupAT3(a,b,c,patch_start,patch_end,version_selector);
+}
 
 class Crate : public Plugin
 {
@@ -324,8 +328,8 @@
 					if (RandomWeapon[Index][2][0] != '\0') {
 						Create_2D_WAV_Sound_Player(sender,RandomWeapon[Index][2]);
 					}
-					message1.Format("ppage %d [Crate] You just got a %s from the Random Weapon crate.mapConfiguration.",Get_Player_ID(sender),RandomWeapon[Index][0]);
-					message2.Format("%ls picked up a Random Weapon crate.mapConfiguration.",Get_Wide_Player_Name(sender));
+					message1.Format("ppage %d [Crate] You just got a %s from the Random Weapon crate.",Get_Player_ID(sender),RandomWeapon[Index][0]);
+					message2.Format("%ls picked up a Random Weapon crate.",Get_Wide_Player_Name(sender));
 					Vector3 pos	= Commands->Get_Position(sender);
 					message3.Format("CRATE;WEAPON;%s;%d;%s;%f;%f;%f;%f;%f;%f;%d",RandomWeapon[Index][0],Commands->Get_ID(sender),Commands->Get_Preset_Name(sender),pos.Y,pos.X,pos.Z,Commands->Get_Facing(sender),Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 				}
@@ -342,13 +346,13 @@
 					}
 					if (RndGood == 1) {
 						message1.Format("ppage %d [Crate] You just got the Money Crate, you have gained %d credits.",Get_Player_ID(sender),(int)Amount);
-						message2.Format("%ls picked up a Money crate.mapConfiguration.",Get_Wide_Player_Name(sender));
+						message2.Format("%ls picked up a Money crate.",Get_Wide_Player_Name(sender));
 						Vector3 pos = Commands->Get_Position(obj);
 						message3.Format("CRATE;MONEY;%d;%d;%s;%f;%f;%f;%f;%f;%f;%d", int(Amount),	Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z,	Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 					}
 					else {
 						message1.Format("ppage %d [Crate] You just got the Demoney Crate, you have lost %d credits.",Get_Player_ID(sender),(int)Amount);
-						message2.Format("%ls picked up a Demoney crate.mapConfiguration.",Get_Wide_Player_Name(sender));
+						message2.Format("%ls picked up a Demoney crate.",Get_Wide_Player_Name(sender));
 						Vector3 pos = Commands->Get_Position(obj);
 						message3.Format("CRATE;MONEY;%d;%d;%s;%f;%f;%f;%f;%f;%f;%d", int(Amount) * -1, Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 					}			
@@ -364,7 +368,7 @@
 					}
 
 					if (RndGood == 1) {
-						message2.Format("%ls picked up a Points crate.mapConfiguration.",Get_Wide_Player_Name(sender));
+						message2.Format("%ls picked up a Points crate.",Get_Wide_Player_Name(sender));
 						message1.Format("ppage %d [Crate] You just got the Points Crate, you have gained %d points.",Get_Player_ID(sender),(int)Amount);
 						StringClass msg;
 						const char *str = Get_Team_Name(Team);
@@ -375,7 +379,7 @@
 						message3.Format("CRATE;POINTS;%d;%d;%s;%f;%f;%f;%f;%f;%f;%d",int(Amount), Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 					}
 					else {
-						message2.Format("%ls picked up a Depoints crate.mapConfiguration.",Get_Wide_Player_Name(sender));
+						message2.Format("%ls picked up a Depoints crate.",Get_Wide_Player_Name(sender));
 						message1.Format("ppage %d [Crate] You just got the Depoints Crate, you lost %d points.",Get_Player_ID(sender),(int)Amount);
 						StringClass msg;
 						const char *str = Get_Team_Name(Team);
@@ -411,10 +415,10 @@
 					else if	(Rnd <=	190) Index = 10;
 					else Index = 11;
 					if (IsPresetDisabled(Get_Definition_ID(RandomVehicle[Index][2]))) goto Reselect2;		
-					message2.Format("%ls picked up a Random Vehicle crate.mapConfiguration.",Get_Wide_Player_Name(sender));
-					message1.Format("ppage %d [Crate] You got a %s from the Random Vehicle crate.mapConfiguration.",Get_Player_ID(sender), RandomVehicle[Index][0]);
+					message2.Format("%ls picked up a Random Vehicle crate.",Get_Wide_Player_Name(sender));
+					message1.Format("ppage %d [Crate] You got a %s from the Random Vehicle crate.",Get_Player_ID(sender), RandomVehicle[Index][0]);
 					StringClass cine;
-					cine.Format("%scrate.mapConfiguration.txt",Commands->Get_Player_Type(sender)	== 0?"Nod":"GDI");
+					cine.Format("%scrate.txt",Commands->Get_Player_Type(sender)	== 0?"Nod":"GDI");
 					Commands->Attach_Script(Temp,"Test_Cinematic",cine);
 					GameObject *veh = Commands->Create_Object(RandomVehicle[Index][3],Vector3(0,0,0));
 					Commands->Send_Custom_Event(Temp,Temp,CUSTOM_EVENT_CINEMATIC_SET_FIRST_SLOT+4,Commands->Get_Preset_ID(veh),0);
@@ -427,7 +431,7 @@
 					message3.Format("CRATE;VEHICLE;%s;%d;%s;%f;%f;%f;%f;%f;%f;%d", RandomVehicle[Index][0], Commands->Get_ID(sender),	Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender),	Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 				}
 				else if	((RandomIntCrate <=	(percent+=crate.mapConfiguration.CrateDeath))	&& (crate.mapConfiguration.CrateDeath	> 0)) {
-					message2.Format("%ls picked up a Death crate.mapConfiguration.",Get_Wide_Player_Name(sender));
+					message2.Format("%ls picked up a Death crate.",Get_Wide_Player_Name(sender));
 					Commands->Apply_Damage(Get_Vehicle(sender),99999,"Shrapnel",0);
 					Commands->Apply_Damage(sender,99999,"Shrapnel",0);
 					Commands->Create_Explosion("Explosion_Mine_Proximity_01",Commands->Get_Position(obj),0);
@@ -442,7 +446,7 @@
 					message3.Format("CRATE;DEATH;;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 				}
 				else if	((RandomIntCrate <=	(percent+=crate.mapConfiguration.CrateTiberium)) && (crate.mapConfiguration.CrateTiberium >	0)) {
-					message2.Format("%ls picked up a Tiberium Death crate.mapConfiguration.",Get_Wide_Player_Name(sender));
+					message2.Format("%ls picked up a Tiberium Death crate.",Get_Wide_Player_Name(sender));
 					Commands->Apply_Damage(Get_Vehicle(sender),99999,"Shrapnel",0);
 					Commands->Apply_Damage(sender,99999,"TiberiumRaw",false);
 					Commands->Create_Object("CnC_Visceroid",Commands->Get_Position(sender));
@@ -456,7 +460,7 @@
 					Commands->Give_PowerUp(sender,"CnC_POW_Ammo_ClipMax",false);
 					Commands->Give_PowerUp(sender,"CnC_POW_Ammo_ClipMax",false);
 					Commands->Give_PowerUp(sender,"CnC_POW_Ammo_ClipMax",false);
-					message2.Format("%ls picked up a Full Ammo crate.mapConfiguration.",Get_Wide_Player_Name(sender));
+					message2.Format("%ls picked up a Full Ammo crate.",Get_Wide_Player_Name(sender));
 					message1.Format("ppage %d [Crate] You just got the Full Ammo Crate, your ammo has been refilled.",Get_Player_ID(sender));
 					Create_2D_WAV_Sound_Player(sender,"m00puar_aqob0002i1evag_snd.wav");
 					Vector3	pos	= Commands->Get_Position(sender);
@@ -467,14 +471,14 @@
 					if (Commands->Get_Shield_Strength(sender) <	2) RndGood = 1;
 					if (RndGood	== 1) {
 						Commands->Give_PowerUp(sender,"POW_Medal_Armor",true);
-						message2.Format("%ls picked up an Armor crate.mapConfiguration.",Get_Wide_Player_Name(sender));
+						message2.Format("%ls picked up an Armor crate.",Get_Wide_Player_Name(sender));
 						message1.Format("ppage %d [Crate] You just got the Armor Crate, your max armor has been increased!",Get_Player_ID(sender));
 						Vector3	pos	= Commands->Get_Position(sender);
 						message3.Format("CRATE;ARMORINCREASE;;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 					}
 					else {
 						Commands->Set_Shield_Strength(sender,1);
-						message2.Format("%ls picked up a Dearmor crate.mapConfiguration.",Get_Wide_Player_Name(sender));
+						message2.Format("%ls picked up a Dearmor crate.",Get_Wide_Player_Name(sender));
 						message1.Format("ppage %d [Crate] You just got the Dearmor Crate, your armor has been set to 1.",Get_Player_ID(sender));
 						Vector3	pos	= Commands->Get_Position(sender);
 						message3.Format("CRATE;ARMORLOST;;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
@@ -485,14 +489,14 @@
 					if (Commands->Get_Health(sender) ==	1) RndGood = 1;
 					if (RndGood	== 1) {
 						Commands->Give_PowerUp(sender,"POW_Medal_Health",true);
-						message2.Format("%ls picked up a Health crate.mapConfiguration.",Get_Wide_Player_Name(sender));
+						message2.Format("%ls picked up a Health crate.",Get_Wide_Player_Name(sender));
 						message1.Format("ppage %d [Crate] You just got the Health Crate, your max health has been increased!",Get_Player_ID(sender));
 						Vector3	pos	= Commands->Get_Position(sender);
 						message3.Format("CRATE;HEALTHUPGRADE;;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 					}
 					else {
 						Commands->Set_Health(sender,1);
-						message2.Format("%ls picked up a Dehealth crate.mapConfiguration.",Get_Wide_Player_Name(sender));
+						message2.Format("%ls picked up a Dehealth crate.",Get_Wide_Player_Name(sender));
 						message1.Format("ppage %d [Crate] You just got the Dehealth Crate, your health has been set to 1.",Get_Player_ID(sender));
 						Create_2D_WAV_Sound_Player(sender,"m00evag_dsgn0026i1evag_snd.wav");
 						Vector3 pos = Commands->Get_Position(sender);
@@ -522,16 +526,16 @@
 					else if (Team == 0 && IsPresetDisabled(Get_Definition_ID(RandomNodChar[Index][1]))) {
 						goto Reselect3;
 					}
-					message2.Format("%ls picked up a Random Character crate.mapConfiguration.",Get_Wide_Player_Name(sender));
+					message2.Format("%ls picked up a Random Character crate.",Get_Wide_Player_Name(sender));
 					if (Commands->Get_Player_Type(sender) == 1) {
 						Change_Character(sender,RandomGDIChar[Index][1]);
-						message1.Format("ppage %d [Crate] You have been transformed into a %s by the Random Character crate.mapConfiguration.",Get_Player_ID(sender),RandomGDIChar[Index][0]);
+						message1.Format("ppage %d [Crate] You have been transformed into a %s by the Random Character crate.",Get_Player_ID(sender),RandomGDIChar[Index][0]);
 						Vector3	pos	= Commands->Get_Position(sender);
 						message3.Format("CRATE;CHARACTER;%s;%d;%s;%f;%f;%f;%f;%f;%f;%d", RandomGDIChar[Index][0],	Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z,	Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 					}
 					else {
 						Change_Character(sender,RandomNodChar[Index][1]);
-						message1.Format("ppage %d [Crate] You have been transformed into a %s by the Random Character crate.mapConfiguration.",Get_Player_ID(sender),RandomNodChar[Index][0]);
+						message1.Format("ppage %d [Crate] You have been transformed into a %s by the Random Character crate.",Get_Player_ID(sender),RandomNodChar[Index][0]);
 						Vector3	pos	= Commands->Get_Position(sender);
 						message3.Format("CRATE;CHARACTER;%s;%d;%s;%f;%f;%f;%f;%f;%f;%d", RandomNodChar[Index][0],	Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z,	Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 					}
@@ -547,14 +551,14 @@
 						Commands->Give_PowerUp(sender,"CnC_POW_MineTimed_Player_01",false);
 						Commands->Select_Weapon(sender,"CnC_Weapon_MineTimed_Player");
 					}
-					message2.Format("%ls picked up the Butter Fingers crate.mapConfiguration.",Get_Wide_Player_Name(sender));
+					message2.Format("%ls picked up the Butter Fingers crate.",Get_Wide_Player_Name(sender));
 					message1.Format("ppage %d [Crate] You picked up the Butter Fingers Crate, you have dropped most of your weapons.",Get_Player_ID(sender));
 					Vector3	pos	= Commands->Get_Position(sender);
 					message3.Format("CRATE;BUTTERFINGER;;%d;%s;%f;%f;%f;%f;%f;%f;%d",Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z,	Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 				}
 				else if	((RandomIntCrate <=	(percent+=crate.mapConfiguration.CrateRefill)) &&	(crate.mapConfiguration.CrateRefill >	0)) {
 					Grant_Refill(sender);
-					message2.Format("%ls picked up the Refill crate.mapConfiguration.",Get_Wide_Player_Name(sender));
+					message2.Format("%ls picked up the Refill crate.",Get_Wide_Player_Name(sender));
 					message1.Format("ppage %d [Crate] You just got the Refill Crate, your health, armor, and ammo have all been refilled.",Get_Player_ID(sender));
 					Create_2D_WAV_Sound_Player(sender,"m00puar_aqob0002i1evag_snd.wav");
 					Vector3	pos	= Commands->Get_Position(sender);
@@ -566,7 +570,7 @@
 					}
 					int	RndGood	= Commands->Get_Random_Int(1,3);
 					if (RndGood	== 1) {
-						message2.Format("%ls picked up a Beacon crate.mapConfiguration.",Get_Wide_Player_Name(sender));
+						message2.Format("%ls picked up a Beacon crate.",Get_Wide_Player_Name(sender));
 						if (Commands->Get_Player_Type(sender) == 1) {
 							TeamPurchaseSettingsDefClass *PT = TeamPurchaseSettingsDefClass::Get_Definition(TeamPurchaseSettingsDefClass::TEAM_GDI);
 							Commands->Give_PowerUp(sender,Get_Definition_Name(PT->Get_Beacon_Definition()),true);
@@ -586,7 +590,7 @@
 						Commands->Create_Object("Beacon_Nuke_Strike_Anim_Post",Commands->Get_Position(obj));
 						Commands->Create_Explosion("Explosion_NukeBeacon",Commands->Get_Position(obj),0);
 						Damage_All_Objects_Area(2500.0f,"None",Commands->Get_Position(obj),15.0f,obj,0);
-						message2.Format("%ls picked up a Nuclear Bomb crate.mapConfiguration.",Get_Wide_Player_Name(sender));
+						message2.Format("%ls picked up a Nuclear Bomb crate.",Get_Wide_Player_Name(sender));
 						message1.Format("ppage %d [Crate] You just got a Nuclear Bomb Crate, you have been killed. Sorry :(",Get_Player_ID(sender));
 						StringClass msg;
 						const char *str = Get_Team_Name(Team);
@@ -601,7 +605,7 @@
 					Change_Character(sender,"CnC_Nod_FlameThrower_2SF");
 					Commands->Set_Is_Visible(sender,false);
 					const char *str3 = Get_Team_Name(Team);
-					message2.Format("A %s player picked up a Spy crate.mapConfiguration.",str3);
+					message2.Format("A %s player picked up a Spy crate.",str3);
 					delete[] str3;
 					message1.Format("ppage %d [Crate] You got the Spy Crate, base defenses will ignore you until you die, buy a new character or destroy a building.",Get_Player_ID(sender));
 					StringClass msg;
@@ -616,14 +620,14 @@
 				}
 				else if	((RandomIntCrate <=	(percent+=crate.mapConfiguration.CrateStealth)) && (crate.mapConfiguration.CrateStealth	> 0)) {
 					Commands->Enable_Stealth(sender,true);
-					message2.Format("%ls picked up a Stealth crate.mapConfiguration.",Get_Wide_Player_Name(sender));
+					message2.Format("%ls picked up a Stealth crate.",Get_Wide_Player_Name(sender));
 					message1.Format("ppage %d [Crate] You got the stealth crate! You have been given a stealth suit.",Get_Player_ID(sender));
 					Vector3	pos	= Commands->Get_Position(sender);
 					message3.Format("CRATE;STEALTH;;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender), Commands->Get_Preset_Name(sender),	pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 				}
 				else if	((RandomIntCrate <=	(percent+=crate.mapConfiguration.CrateThief))	&& (crate.mapConfiguration.CrateThief	> 0)) {
 					Commands->Give_Money(sender,(Commands->Get_Money(sender) * -1),false);
-					message2.Format("%ls picked up a Thief crate.mapConfiguration.",Get_Wide_Player_Name(sender));
+					message2.Format("%ls picked up a Thief crate.",Get_Wide_Player_Name(sender));
 					message1.Format("ppage %d [Crate] You got the Thief Crate, you have lost all of your credits.",Get_Player_ID(sender));
 					Create_2D_Sound_Player(sender,"m00evag_dsgn0028i1evag_snd.wav");
 					Vector3	pos	= Commands->Get_Position(sender);
@@ -631,7 +635,7 @@
 				}
 				else if	((RandomIntCrate <=	(percent+=crate.mapConfiguration.CrateAmmoRegen))	&& (crate.mapConfiguration.CrateAmmoRegen	> 0)) {
 					Commands->Send_Custom_Event(obj,sender,100100,1,1);//enable regeneration of ammo on player
-					message2.Format("%ls picked up a Ammo Regeneration crate.mapConfiguration.",Get_Wide_Player_Name(sender));
+					message2.Format("%ls picked up a Ammo Regeneration crate.",Get_Wide_Player_Name(sender));
 					message1.Format("ppage %d [Crate] You got the Ammo Reneration Crate, your ammo will be refilled every minute.",Get_Player_ID(sender));
 					Create_2D_Sound_Player(sender,"m00puar_aqob0002i1evag_snd.wav");//ammo regen sound
 					Vector3	pos	= Commands->Get_Position(sender);
@@ -640,7 +644,7 @@
 				else if	((RandomIntCrate <=	(percent+=crate.mapConfiguration.CrateHumanSilo))	&& (crate.mapConfiguration.CrateHumanSilo	> 0)) {
 					int team = Commands->Get_Player_Type(sender);
 					Commands->Send_Custom_Event(obj,sender,100101,1,1);//enable generating of money on player
-					message2.Format("%ls picked up a Human Silo crate.mapConfiguration.",Get_Wide_Player_Name(sender));
+					message2.Format("%ls picked up a Human Silo crate.",Get_Wide_Player_Name(sender));
 					message1.Format("ppage %d [Crate] You got the Human Silo Crate, your entier team will be granted an additional $1 credit a second until you die or change character.",Get_Player_ID(sender));
 					Create_2D_WAV_Sound_Team("m00pc$$_aqob0002i1evag_snd.wav",team);//credits acquired
 					Vector3	pos	= Commands->Get_Position(sender);
@@ -648,8 +652,8 @@
 				}
 				else if	((RandomIntCrate <=	(percent+=crate.mapConfiguration.CrateUberWire))	&& (crate.mapConfiguration.CrateUberWire	> 0)) {
 					char ubermsg[250]; sprintf(ubermsg,"[CRATE] %s got the UberWire crate! Beware!",Get_Player_Name(sender)); Send_Message(255,255,255,ubermsg);
-					message2.Format("%ls picked up a UberWire crate.mapConfiguration.",Get_Wide_Player_Name(sender));
-					message1.Format("ppage %d [Crate] You got the UberWire crate.mapConfiguration.",Get_Player_ID(sender));
+					message2.Format("%ls picked up a UberWire crate.",Get_Wide_Player_Name(sender));
+					message1.Format("ppage %d [Crate] You got the UberWire crate.",Get_Player_ID(sender));
 					Vector3	pos	= Commands->Get_Position(sender);
 					message3.Format("CRATE;UBERWIRE;;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 					Change_Character(sender,"GDI_Engineer_2SF");
diff -uwr sourceold/example-plugin/ExamplePlugin.cpp source/example-plugin/ExamplePlugin.cpp
--- sourceold/example-plugin/ExamplePlugin.cpp	2011-10-11 21:33:27.709960900 +0800
+++ source/example-plugin/ExamplePlugin.cpp	2012-01-11 22:19:43.840820300 +0800
@@ -15,6 +15,11 @@
 #include "engine_io.h"
 #include "gmgame.h"
 
+void* HookupAT3x(void* a, void* b, void* c, void* patch_start, void* patch_end, int (*version_selector)())
+{
+	return HookupAT3(a,b,c,patch_start,patch_end,version_selector);
+}
+
 ExamplePlugin::ExamplePlugin()
 {
 	Console_Output(__FUNCTION__ "\n");
diff -uwr sourceold/randomstartingcredits/RandomStartingCredits.cpp source/randomstartingcredits/RandomStartingCredits.cpp
--- sourceold/randomstartingcredits/RandomStartingCredits.cpp	2011-10-11 21:36:29.291015600 +0800
+++ source/randomstartingcredits/RandomStartingCredits.cpp	2012-01-11 22:20:56.575195300 +0800
@@ -13,6 +13,10 @@
 #include "RandomStartingCredits.h"
 #include "gmgame.h"
 
+void* HookupAT3x(void* a, void* b, void* c, void* patch_start, void* patch_end, int (*version_selector)())
+{
+	return HookupAT3(a,b,c,patch_start,patch_end,version_selector);
+}
 
 class RANDOMSTARTINGCREDITS : public Plugin
 {
diff -uwr sourceold/scripts/AudibleSoundClass.h source/scripts/AudibleSoundClass.h
--- sourceold/scripts/AudibleSoundClass.h	2011-12-08 11:43:52.666992100 +0800
+++ source/scripts/AudibleSoundClass.h	2012-02-21 10:03:50.199218700 +0800
@@ -62,7 +62,7 @@
    float               volume;            // 132  84
    float               pan;               // 136  88
    uint32              loopCount;         // 140  8C
-   uint32              remainingLoops;    // 144  90
+   int32               remainingLoops;    // 144  90
    uint32              duration;          // 148  94
    uint32              playPosition;      // 152  98
    float               startPosition;     // 156  9C
@@ -165,7 +165,7 @@
 
   AudibleSoundClass& operator = (const AudibleSoundClass& sound);
 
-}; // 328 144
+}; // 328 148
 
 
 #endif
diff -uwr sourceold/scripts/BeaconGameObjDef.h source/scripts/BeaconGameObjDef.h
--- sourceold/scripts/BeaconGameObjDef.h	2011-10-11 21:57:34.518554600 +0800
+++ source/scripts/BeaconGameObjDef.h	2012-01-13 08:30:18.359375000 +0800
@@ -40,7 +40,7 @@
 	int DisarmingInterruptedTextID; // 00D8
 	int PreDetonateCinematicObjDef; // 00DC
 	int PostDetonateCinematicObjDef; // 00E0
-	uint32 ExplosionObjDef; // 00E4
+	int ExplosionObjDef; // 00E4
 	int IsNuke; // 00E8
 	StringClass ArmingAnimationName; // 00EC
 	friend class BeaconGameObj;
diff -uwr sourceold/scripts/Defines.h source/scripts/Defines.h
--- sourceold/scripts/Defines.h	2011-10-14 19:58:40.176757800 +0800
+++ source/scripts/Defines.h	2012-01-11 22:17:29.541992100 +0800
@@ -223,6 +223,7 @@
 SCRIPTS_API void InitEngine();
 SCRIPTS_API int		RenegadeAT3VersionSelector(); // Default implementation, used by AT1/AT2
 SCRIPTS_API void*	HookupAT3(void* a, void* b, void* c, void* patch_start, void* patch_end, int (*function_selector)());
+void* HookupAT3x(void* a, void* b, void* c, void* patch_start, void* patch_end, int (*version_selector)());
 #define RENEGADE_FUNCTION  __declspec(naked)
 #ifndef TTLE_EXPORTS
 #define AT1(client)						AT2(client, 0)
@@ -243,7 +244,7 @@
 	__asm push c					\
 	__asm push b					\
 	__asm push a					\
-	__asm call HookupAT3			\
+	__asm call HookupAT3x			\
 	__asm AT3PatchEnd:				\
 	__asm add esp, 24				\
 	__asm pop edx					\
diff -uwr sourceold/scripts/GameData.h source/scripts/GameData.h
--- sourceold/scripts/GameData.h	2011-10-11 21:53:00.882812500 +0800
+++ source/scripts/GameData.h	2012-02-13 16:27:27.384187500 +0800
@@ -188,6 +188,8 @@
 	void Swap_Team_Sides();
 	void Remix_Team_Sides();
 	void Rebalance_Team_Sides();
+	int Choose_Available_Team(int type);
+	int Choose_Smallest_Team();
 
 	void Reset_Time_Remaining_Seconds() { TimeRemaining_Seconds = (float)(TimeLimit_Minutes * 60); }
 	void Set_Time_Remaining_Seconds(float time) {TimeRemaining_Seconds = time;}
diff -uwr sourceold/scripts/GameObjManager.h source/scripts/GameObjManager.h
--- sourceold/scripts/GameObjManager.h	2011-10-11 21:52:57.000976500 +0800
+++ source/scripts/GameObjManager.h	2012-02-13 13:28:20.240632800 +0800
@@ -40,6 +40,8 @@
 	static SCRIPTS_API REF_DECL3(SmartGameObjList, SList<SmartGameObj>);
 	static SHADERS_API SList<C4GameObj> C4GameObjList;
 	static SHADERS_API SList<BeaconGameObj> BeaconGameObjList;
+	static SHADERS_API SList<SoldierGameObj> SoldierGameObjList;
+	static SHADERS_API SList<VehicleGameObj> VehicleGameObjList;
 #ifndef TTLE_EXPORTS
 	static REF_DECL2(CinematicFreezeActive, bool);
 #endif
diff -uwr sourceold/scripts/MeshClass.h source/scripts/MeshClass.h
--- sourceold/scripts/MeshClass.h	2011-10-11 21:50:03.804687500 +0800
+++ source/scripts/MeshClass.h	2012-01-11 20:59:06.600585900 +0800
@@ -91,8 +91,6 @@
 	void								Set_Base_Vertex_Offset(int base) { BaseVertexOffset = base; }
 	int								Get_Base_Vertex_Offset(void) { return BaseVertexOffset; }
 	static bool						Legacy_Meshes_Fogged;
-	void								Replace_Texture(TextureClass* texture,TextureClass* new_texture);
-	void								Replace_VertexMaterial(VertexMaterialClass* vmat,VertexMaterialClass* new_vmat);
 	SHADERS_API void								Make_Unique();
 	unsigned							Get_Debug_Id() const { return  MeshDebugId; }
 	void								Set_Debugger_Disable(bool b) { IsDisabledByDebugger=b; }
